

/*
  Horloge parlante  avec CI DS3231, Afficheur 64*128 et module vocal DFPlayer_Mini
  utilisant une carte SD.

  Mon site: http://f5mna.free.fr

  Juin 2016
*/

#include <U8glib.h>
#include <Wire.h>
#include <math.h>
#include <DS1307new.h>

/////////////////Parlante
#include <SoftwareSerial.h>
#include <DFPlayer_Mini_Mp3.h>
SoftwareSerial mySerial(10, 11); // RX, TX
//////////////////////////////////////////////////

U8GLIB_ST7920_128X64_1X u8g(6, 5, 4 , 7); // Pour ST7920 128*64

//Horloge
int angles, anglem, angleh, xs, ys, xm, ym, xh, yh;
float rad;

//DS3231 / DS3232
/*
  CI DS3232
  VDD  3VCC ou 5VCC
  SDA  A4
  SCL  A5
*/
//////////////////////////////////////////////////
int I2C_DS3232 = 0xD0 >> 1;
byte DS3232control = 0b00011100, DS3232status = 0b11001000 , DS3232aging , DS3232Msb , DS3232Lsb;
//////////////////////////////////////////////////
uint16_t startAddr = 0x0000;       // Adresse de démarrage Start dans  NV-RAM
uint16_t lastAddr;                 // Nelle addresse de stockage NV-RAM
uint16_t TimeIsSet = 0xaa55;       // Prévient qu'il n'y a pas de remise à l'heure

#define Touche_PIN  A0 // Entree platine 4 Boutons poussoirs
int sensorPin = A0;
int sensorValue = 0;
int val_key;
int Select;
int Heure;
int Minute;
int Seconde;
int Jour;
int Mois;
int Annee;
int JourSem;

void setup () {
  ///// Parlante
   mySerial.begin(9600);
   delay(400);
   mp3_set_serial (mySerial); //set softwareSerial for DFPlayer-mini mp3 module 
   delay(400);
   mp3_set_volume (25); //  Volume de 0 à 30 
   delay(400);
 /////////
  RTC.setRAM(0, (uint8_t *)&startAddr, sizeof(uint16_t));// Entree startAddr in NV-RAM address 0x08
  TimeIsSet = 0xffff;
  RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
  RTC.ctrl = 0x00;     // 0x00=disable SQW pin, 0x10=1Hz,
  // 0x11=4096Hz, 0x12=8192Hz, 0x13=32768Hz
  RTC.setCTRL();

  pinMode( Touche_PIN, INPUT );         //Défini A0 comme entrée
  digitalWrite( Touche_PIN, LOW );      //A0 en possition 0.

  u8g.setFont(u8g_font_6x12); //Font Afficheur
  // u8g.setFont(u8g_font_fur14); //Font Afficheur

  rad = ((2 * 3.1415926536) / 360);   
}
//////////////////////////////////////////////////////////////////////////////////

void Horloge()
{
  sensorValue = analogRead(sensorPin); // lecture de la touche
  val_key = int(sensorValue / 10);    // valeur entière de la touche / 10

  /// Affichage marche////
  if  (Select == 0)
  {
    RTC.getTime();
    Heure = RTC.hour;
    Minute = RTC.minute;
    Seconde = RTC.second;
    Jour = RTC.day;
    Mois = RTC.month;
    Annee = RTC.year;

    //FONT
    u8g.setFont(u8g_font_timB14);

    if (Heure < 10) {
      u8g.drawStr( 60, 26, "0");
      u8g.setPrintPos(69, 26); //Heure
      u8g.print(Heure);
    }
    else
    { u8g.setPrintPos(61, 25); //Heure
      u8g.print(Heure);
    }

    u8g.drawStr( 78, 25, ":");

    if (Minute < 10) {
      u8g.drawStr( 84, 25, "0");
      u8g.setPrintPos( 94, 25);//Minute
      u8g.print(Minute);
    }
    else
    { u8g.setPrintPos( 85, 25);//Minute
      u8g.print(Minute);
    }

    u8g.drawStr( 102, 25, ":");

    if (Seconde < 10) {
      u8g.drawStr( 108, 25, "0");
      u8g.setPrintPos( 117, 25);//Seconde
      u8g.print(Seconde);
    }
    else
    { u8g.setPrintPos(108, 25);//Seconde
      u8g.print(Seconde);
    }


    u8g.setFont(u8g_font_5x7); //Font Afficheur

    //////////////////////////////////////////////////////////////////////////////
    switch (RTC.dow)
    {
      case 1:
        u8g.drawStr( 73, 47, " Lundi  ");
        break;
      case 2:
        u8g.drawStr( 73, 47, " Mardi  ");
        break;
      case 3:
        u8g.drawStr( 73, 47, "Mercredi");
        break;
      case 4:
        u8g.drawStr( 73, 47, " Jeudi  ");
        break;
      case 5:
        u8g.drawStr( 73, 47, "Vendredi");
        break;
      case 6:
        u8g.drawStr( 73, 47, " Samedi ");
        break;
      case 0:
        u8g.drawStr( 73, 47, "Dimanche");
        break;
    }

    //////////////////////////////////////////////////////
    if (Jour < 10) {
      u8g.drawStr( 57, 57, "0");
      u8g.setPrintPos(62, 57); //Jour
      u8g.print(Jour);
    }
    else
    { u8g.setPrintPos(57, 57); //Jour
      u8g.print(Jour);
    }

    switch (RTC.month) {
      case 1:
        u8g.drawStr( 70, 57, "Janvier");
        break;
      case 2:
        u8g.drawStr( 70, 57, "fevrier");
        break;
      case 3:
        u8g.drawStr( 70, 57, "  mars");
        break;
      case 4:
        u8g.drawStr( 70, 57, " avril ");
        break;
      case 5:
        u8g.drawStr( 70, 57, "  mai  ");
        break;
      case 6:
        u8g.drawStr( 70, 57, " juin  ");
        break;
      case 7:
        u8g.drawStr( 70, 57, "Juillet");
        break;
      case 8:
        u8g.drawStr( 69, 57, "  aout  ");
        break;
      case 9:
        u8g.drawStr( 70, 57, " septe.");
        break;
      case 10:
        u8g.drawStr( 69, 57, "octobre");
        break;
      case 11:
        u8g.drawStr( 70, 57, "novemb.");
        break;
      case 12:
        u8g.drawStr( 70, 57, "decemb.");
        break;
    }
    u8g.setPrintPos(106, 57); //Année
    u8g.print(Annee);
  }
  ///////////////////////////////
  //Dessin horloge - Aiguilles///
  ///////////////////////////////
  angles = (Seconde * 6) - 90;
  anglem = (Minute * 6) - 90;
  angleh = ((Heure * 30) - 90) + ((anglem / 12) + 6);
  Serial.println (angleh);

  u8g.drawCircle(31, 32, 21);
  u8g.drawCircle(31, 32, 19);

  u8g.setFont(u8g_font_micro);
  u8g.drawStr( 56, 35, "3");
  u8g.drawStr( 30, 60, "6");
  u8g.drawStr( 3, 35, "9");
  u8g.drawStr( 28, 10, "12");

  u8g.drawStr( 40, 16, "."); //1
  u8g.drawStr( 47, 24, "."); //2
  u8g.drawStr( 50, 33, "."); //3
  u8g.drawStr( 47, 42, ".");  //4
  u8g.drawStr( 41, 50, ".");  //5
  u8g.drawStr( 31, 53, ".");  //6
  u8g.drawStr( 21, 50, ".");  //7
  u8g.drawStr( 14, 42, ".");  //8
  u8g.drawStr( 11, 33, ".");  //9
  u8g.drawStr( 14, 24, ".");  //10
  u8g.drawStr( 21, 16, ".");  //11
  u8g.drawStr( 31, 14, "."); //12

  xs = 31 + (cos(angles * rad) * 18);
  ys = 32 + (sin(angles * rad) * 18);
  u8g.drawLine(31, 32, xs, ys);


  xm = 31 + (cos(anglem * rad) * 16);
  ym = 32 + (sin(anglem * rad) * 16);
  u8g.drawLine(31, 32, xm, ym);
  u8g.drawLine(32, 31, xm, ym);


  xh = 31 + (cos(angleh * rad) * 10);
  yh = 32 + (sin(angleh * rad) * 10);
  u8g.drawLine(31, 32, xh, yh);
  u8g.drawLine(32, 31, xh, yh);


  ///////////////////////////////////////////////////////////////////////////////////////////
  //                                  R E G L A G E                                        //
  ///////////////////////////////////////////////////////////////////////////////////////////


  if ((Select > 0) and (Select < 8))
  {
    u8g.drawStr(80, 18, "REGLAGES");

    if (Jour < 10)  {
      u8g.drawStr( 73, 30, "0");
      u8g.setPrintPos(77, 30); //Jour
      u8g.print(Jour);
    }
    else
    { u8g.setPrintPos(73, 30); //jour
      u8g.print(Jour);
    }

    u8g.drawStr( 83, 30, ":");

    if (Mois < 10) {
      u8g.drawStr( 89, 30, "0");
      u8g.setPrintPos( 94, 30);//Mois
      u8g.print(Mois);
    }
    else
    { u8g.setPrintPos(89, 30); //Mois
      u8g.print(Mois);
    }

    u8g.drawStr( 100, 30, ":");

    u8g.setPrintPos( 105, 30);//Annee
    u8g.print(Annee);

    if (Heure < 10) {
      u8g.drawStr( 78, 40, "0");
      u8g.setPrintPos(82, 40); //Heure
      u8g.print(Heure);
    }
    else
    { u8g.setPrintPos(78, 40); //Heure
      u8g.print(Heure);
    }

    u8g.drawStr( 88, 40, ":");

    if (Minute < 10) {
      u8g.drawStr(93, 40, "0");
      u8g.setPrintPos( 98, 40);//Minute
      u8g.print(Minute);
    }
    else
    { u8g.setPrintPos( 93, 40);//Minute
      u8g.print(Minute);
    }

    u8g.drawStr( 105, 40, ":");

    if (Seconde < 10) {
      u8g.drawStr(110, 40, "0");
      u8g.setPrintPos( 115, 40);//Seconde
      u8g.print(Seconde);
    }
    else
    { u8g.setPrintPos( 110, 40);//Seconde
      u8g.print(Seconde);
    }
  }

  val_key = 0;                           // RAZ valeur de la touche
  sensorValue = analogRead(sensorPin);   // lecture de la touche
  val_key = int(sensorValue / 100);      // valeur entière de la touche / 100

  ////////////////////////////////////////////////////////
  /////////// Selection des reglages /////////////////////
  ////////////////////////////////////////////////////////

  switch (val_key)
  {
    delay (200);
    case 7:                              //  7: Valeur de la touche "Parole" à modifier selon pavé boutons  ////////////////////////////////////////////////////////////////////////
      Parlante();
      break;

    case 0 : //Select
      {
        Select = (Select + 1);
        delay (200);
      }
      break;
  }

  if (Select == 1) u8g.drawStr(70, 50, " Reglage jour");

  if (Select == 2) u8g.drawStr(70, 50, " Reglage mois");

  if (Select == 3) u8g.drawStr(65, 50, " Reglage annee");

  if (Select == 4) u8g.drawStr(70, 50, "Reglage heures");

  if (Select == 5) u8g.drawStr(70, 50, "Reglage minutes");

  if (Select == 6) u8g.drawStr(65, 50, "Reglage Secondes");

  if (Select == 7) u8g.drawStr(90 , 50, "TOP !");

  if (Select == 8) {
    (Select = 0);
    RTC.setRAM(0, (uint8_t *)&startAddr, sizeof(uint16_t));// Entrée startAddr dans NV-RAM address 0x08
    TimeIsSet = 0xffff;
    RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
    if (TimeIsSet != 0xaa55)
    {
      RTC.stopClock();
      RTC.fillByYMD(Annee, Mois, Jour);
      RTC.fillByHMS(Heure, Minute, Seconde);

      RTC.setTime();
      TimeIsSet = 0xaa55;
      RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
      RTC.startClock();
    }
    else
    {
      RTC.getTime();
    }
  }

  switch (val_key)
  {
    case 4: //Down    ///     1: Valeur de la touche "Down" à modifier selon pavé boutons  /////////////////////////////////////////////////////////////////////////////
      {
        delay (200);
        if (Select == 1) {
          Jour = (Jour - 1);
        }
        if (Jour < 1) {
          (Jour = 31);
        }
        if (Select == 2) {
          Mois = (Mois - 1);
        }
        if (Mois < 1) {
          (Mois = 12);
        }
        if (Select == 3) {
          Annee = (Annee - 1);
        }

        if (Select == 4) {
          Heure = (Heure - 1);
        }
        if (Heure < 1) {
          (Heure = 23);
        }
        if (Select == 5) {
          Minute = (Minute - 1);
        }
        if (Minute < 1) {
          (Minute = 59);
        }
        if (Select == 6) {
          Seconde = (Seconde - 1);
        }
        if (Seconde < 1) {
          (Seconde = 59);
        }
      }
      break;

    case 3: //UP      ////3: Valeur de la touche "Up" à modifier selon pavé boutons    ////////////////////////////////////////////////////////////////////
      {
        delay (200);
        if (Select == 1) {
          Jour = (Jour + 1);
        }
        if (Jour > 31) {
          (Jour = 1);
        }
        if (Select == 2) {
          Mois = (Mois + 1);
        }
        if (Mois > 12) {
          (Mois = 1);
        }
        if (Select == 3) {
          Annee = (Annee + 1);
        }

        if (Select == 4) {
          Heure = (Heure + 1);
        }
        if (Heure > 23) {
          (Heure = 0);
        }
        if (Select == 5) {
          Minute = (Minute + 1);
        }
        if (Minute > 59 ) {
          (Minute = 0);
        }
        if (Select == 6) {
          Seconde = (Seconde + 1);
        }
        if (Seconde > 59) {
          (Seconde = 0);
        }
      }
      break;
  }
}
////////////////////////////////////////////////
/////////////////////////////////////////////////

///////////////////////////////////////////////// 
void Parlante()
{
  mp3_play (3300); //il est
  delay (650);

  switch (Heure) {

    case 0:
      mp3_play (2200); //zero
      delay (850);
      break;

    case 1:
      mp3_play (2201); //1
      delay (750);
      break;

    case 2:
      mp3_play (2202); //2
      delay (750);
      break;

    case 3:
      mp3_play (2203); //3
      delay (750);
      break;

    case 4:
      mp3_play (2204); //4
      delay (750);
      break;

    case 5:
      mp3_play (2205); //5
      delay (750);
      break;

    case 6:
      mp3_play (2206); //6
      delay (750);
      break;

    case 7:
      mp3_play (2207); //7
      delay (750);
      break;

    case 8:
      mp3_play (2208); //8
      delay (750);
      break;

    case 9:
      mp3_play (2209); //9
      delay (750);
      break;

    case 10:
      mp3_play (2210); //10
      delay (750);
      break;

    case 11:
      mp3_play (2211); //11
      delay (750);
      break;

    case 12:
      mp3_play (2212); //12
      delay (750);
      break;

    case 13:
      mp3_play (2213); //13
      delay (750);
      break;

    case 14:
      mp3_play (2214); //14
      delay (900);
      break;

    case 15:
      mp3_play (2215); //15
      delay (750);
      break;

    case 16:
      mp3_play (2216); // 16
      delay (750);
      break;

    case 17:
      mp3_play (2217); //10
      delay (850);
      break;

    case 18:
      mp3_play (2218); //10
      delay (850);
      break;

    case 19:
      mp3_play (2219); //10
      delay (850);
      break;

    case 20:
      mp3_play (2220); //20
      delay (750);
      break;

    case 21:
      mp3_play (2221); //20
      delay (950);
      break;

    case 22:
      mp3_play (2222); //20
      delay (1000);
      break;

    case 23:
      mp3_play (2223); //20
      delay (1000);
      break;
  }

  // mp3_play (3301); //  et
  delay (250);
  //////////////////////////////////////////////
  //////////////////////////////////////////////
  switch (Minute) {

    case 0:
      mp3_play (1100); //zero
      delay (250);
      break;

    case 1:
      mp3_play (1101); //1
      delay (250);
      break;

    case 2:
      mp3_play (1102); //2
      delay (250);
      break;

    case 3:
      mp3_play (1103); //3
      delay (250);
      break;

    case 4:
      mp3_play (1104); //4
      delay (250);
      break;

    case 5:
      mp3_play (1105); //5
      delay (250);
      break;

    case 6:
      mp3_play (1106); //6
      delay (250);
      break;

    case 7:
      mp3_play (1107); //7
      delay (250);
      break;

    case 8:
      mp3_play (1108); //8
      delay (250);
      break;

    case 9:
      mp3_play (1109); //9
      delay (250);
      break;

    case 10:
      mp3_play (1110); //10
      delay (250);
      break;

    case 11:
      mp3_play (1111); //11
      delay (250);
      break;

    case 12:
      mp3_play (1112); //12
      delay (250);
      break;

    case 13:
      mp3_play (1113); //13
      delay (250);
      break;

    case 14:
      mp3_play (1114); //14
      delay (250);
      break;

    case 15:
      mp3_play (1115); //15
      delay (250);
      break;

    case 16:
      mp3_play (1116); // 16
      delay (250);
      break;

    case 17:
      mp3_play (1117); //10
      delay (250);
      break;

    case 18:
      mp3_play (1118); //10
      delay (250);
      break;

    case 19:
      mp3_play (1119); //10
      delay (250);
      break;

    case 20:
      mp3_play (1120); //20
      delay (250);
      break;

    case 21:
      mp3_play (1121); //21
      delay (250);
      break;

    case 22:
      mp3_play (1122); //22
      delay (250);
      break;

    case 23:
      mp3_play (1123); //23
      delay (250);
      break;

    case 24:
      mp3_play (1124); //24
      delay (250);
      break;

    case 25:
      mp3_play (1125); //25
      delay (250);
      break;

    case 26:
      mp3_play (1126); //26
      delay (250);
      break;

    case 27:
      mp3_play (1127); //27
      delay (250);
      break;

    case 28:
      mp3_play (1128); //28
      delay (250);
      break;

    case 29:
      mp3_play (1129); //29
      delay (250);
      break;

    case 30:
      mp3_play (1130); //30
      delay (250);
      break;

    case 31:
      mp3_play (1131); //31
      delay (300);
      break;

    case 32:
      mp3_play (1132); //32
      delay (350);
      break;

    case 33:
      mp3_play (1133); //33
      delay (350);
      break;

    case 34:
      mp3_play (1134); //34
      delay (350);
      break;

    case 35:
      mp3_play (1135); //35
      delay (350);
      break;

    case 36:
      mp3_play (1136); //36
      delay (250);
      break;

    case 37:
      mp3_play (1137); //37
      delay (350);
      break;

    case 38:
      mp3_play (1138); //38
      delay (350);
      break;

    case 39:
      mp3_play (1139); //39
      delay (350);

      break;

    case 40:
      mp3_play (1140); //40
      delay (750);
      break;

    case 41:
      mp3_play (1141); //41
      delay (750);
      break;

    case 42:
      mp3_play (1142); //42
      delay (750);
      break;

    case 43:
      mp3_play (1143); //43
      delay (750);

      break;

    case 44:
      mp3_play (1144); //44
      delay (750);
      break;

    case 45:
      mp3_play (1145); //45
      delay (750);
      break;

    case 46:
      mp3_play (1146); //46
      delay (750);
      break;

    case 47:
      mp3_play (1147); //47
      delay (750);
      break;

    case 48:
      mp3_play (1148); //48
      delay (750);
      break;

    case 49:
      mp3_play (1149); //49
      delay (750);
      break;

    case 50:
      mp3_play (1150); //50
      delay (600);
      break;

    case 51:
      mp3_play (1151); //51
      delay (600);
      break;

    case 52:
      mp3_play (1152); //52
      delay (600);
      break;

    case 53:
      mp3_play (1153); //53
      delay (600);

      break;

    case 54:
      mp3_play (1154); //54
      delay (600);
      break;

    case 55:
      mp3_play (1155); //55
      delay (600);
      break;

    case 56:
      mp3_play (1156); //56
      delay (600);
      break;

    case 57:
      mp3_play (1157); //57
      delay (600);
      break;

    case 58:
      mp3_play (1158); //58
      delay (600);
      break;

    case 59:
      mp3_play (1159); //59
      delay (600);
      break;
  }
}

void loop()
{
  u8g.firstPage();
  do
    Horloge();
  while ( u8g.nextPage());


}

